function FP = FinaPoravnava(pic,pic2,cpic,cpic2,handle)
% Funkcija poravna dve slike. Prva slika je staticna(v fazi primerjave), druga pa se
% glede na prvo premika. Sliki morata biti istih velikosti.
%
% Kot izhod sta vrnjeni popravljeni sliki.

    pic3 = double(pic2);
    cpic3 = double(cpic2);
    [maxx maxy] = size(pic);
      
    % Ocena poravnave %
    m_cel = [1 0 0 1 0 0]';
    m = m_cel;
    m_star = [0 0 0 0 0 0]';

    % Nastavitev zacetnih vrednosti %
    for x=1:maxy
        pa(:,x) = (1:maxx)';
	end
	for y=1:maxx
        pb(y,:) = (1:maxy);
	end
    
    ppa = pa;
    ppb = pb;
    
    % Ocena zacetnega ujemanja slik %
    E_nova=sqrt(sum(sum((double(pic(1:maxx,1:maxy))-double(pic2(1:maxx,1:maxy))).^2)));
    E_star=E_nova+1;
    E_vsi = [-1];

    st_it = 0;
    ze_5_vec = 0;
    E_min = E_nova;
    M_best = m_cel;
   
    
    % Ponavljam tako dolgo, dokler dobivam razlicne ocene ali pa ne sledi 5
    % slabsih ocen (zelo verjetno,da ne bo sledila boljsa). Dodana je
    % omejitev 50 iteracij, v primeru da stvar zbezlja.
    while and( and(fix(E_star) ~= fix(E_nova), ze_5_vec < 5), st_it<50)%st_it<30 %and((E_nova<E_star), min(round(m_star*1000)==round(m_cel*1000))==0 )
        st_it = st_it +1;
        
        m_star = m_cel;
    
        prva = zeros(6,6);
        druga = zeros(6,1);
       
        ax = pa;
        ay = pb; 

        % Izracun koeficientov m %
	    for y=2:maxy-1      
	    	for  x=2:maxx-1   
	    		fx = Fx(x,y,pic2);				
	    		fy = Fy(x,y,pic2);				
	    		ft = double(pic(x,y))-double(pic2(x,y));	
               
	    		c = [ ax(x,y)*fx, ay(x,y)*fx, ax(x,y)*fy, ay(x,y)*fy, fx, fy ]'; 
		    	cc = c*c';
                prva = prva + cc;
            
	    		ck = c * ( ft + ax(x,y)*fx + ay(x,y)*fy); 
                druga = druga + ck;
            end
       end

       pmat = inv(prva);
	   m = pmat*druga;
		
       % Nov m pristejem k celotnemu %
	   m_cel = m_cel + m;
       m_cel(1) = m_cel(1) - 1; % Pazim na prvo komponento - upostevam samo razliko od 1 
	   m_cel(4) = m_cel(4) - 1; % Pazim na cetrto komponento - upostevam samo razliko od 1 

       % Izracun novih koordinat po premiku z m %
       pa = m(1)*ax + m(2)*ay + m(5);
       pb = m(3)*ax + m(4)*ay + m(6);       
        
       % Interpoliram sliko v novo sliko %
	   pic2 = myinterp2(1:maxy,1:maxx,pic3,pb,pa);

       % Ocenim ujemanje z originalom %
       E_star = E_nova;
       E_nova=sqrt(sum(sum((double(pic)-double(pic2)).^2)));
       
       if E_nova < E_min
           ze_5_vec = 0;
           E_min = E_nova;
           M_best = m_cel;
       else
           ze_5_vec = ze_5_vec + 1;
       end
       
       
       % Sivinski izris trenutnega prilagajanja %
       axis(handle);
       image(uint8(double(pic)/2+double(pic2)/2));
       colormap(gray(256));
       axis equal;
       axis on;
       pause(0.01);
   end
   
   % Vzamem celostno najboljsi m
   m_cel = M_best
   
   clear pic3
   clear ax
   clear ay
   clear pic
   clear pic2
    
    % Popravim drugo sliko glede na celostne koeficiente m - DRUGA slika%
    diff_x = (m_cel(1) - 1) / 2;
    pa = (1+diff_x)*ppa + m_cel(2)/2*ppb + m_cel(5)/2;
    diff_y = (m_cel(4) - 1) / 2;
    pb = m_cel(3)/2*ppa + (1+diff_y)*ppb + m_cel(6)/2;
    
    cpom2(:,:,1) = myinterp2(1:maxy,1:maxx,double(cpic2(:,:,1)),pb,pa);
    cpom2(:,:,2) = myinterp2(1:maxy,1:maxx,double(cpic2(:,:,2)),pb,pa);
    cpom2(:,:,3) = myinterp2(1:maxy,1:maxx,double(cpic2(:,:,3)),pb,pa);
    
    clear cpic2;
    
    pic2 = rgb2gray(uint8(cpom2));
    
    % Popravim drugo sliko glede na celostne koeficiente m %
    pa = (1 - diff_x)*ppa - m_cel(2)/2*ppb - m_cel(5)/2;
    pb = -m_cel(3)/2*ppa + (1 - diff_y)*ppb - m_cel(6)/2;
    
    cpom(:,:,1) = myinterp2(1:maxy,1:maxx,double(cpic(:,:,1)),pb,pa);
    cpom(:,:,2) = myinterp2(1:maxy,1:maxx,double(cpic(:,:,2)),pb,pa);
    cpom(:,:,3) = myinterp2(1:maxy,1:maxx,double(cpic(:,:,3)),pb,pa);
    
    clear cpic;
    
    pic = rgb2gray(uint8(cpom));
    
    % Izhod - prve 3 dimenzije za barvno sliko, 4 za sivinsko %   
    ncpic2(:,:,1:3) = cpom2;
    ncpic2(:,:,4) = pic;
    ncpic2(:,:,5:7) = cpom;
    ncpic2(:,:,8) = pic2;

    FP = uint8(ncpic2);  