function GP = GrobaPoravnava2(pic,pic2,cpic2,cpic,handles)
% Funkcija GrobaPoravnava grobo poravna dve sliki. 
% Kot argumente vzame staticno (pic) sliko in sliko, ki jo zelimo
% translirati/rotirati. Obe sliki sta predhodno filtrirani z nizkim
% filtrom.
% Zadnji argument pa predstavlja nefiltrirano drugo sliko, ki jo na koncu
% dejansko transliramo/rotiramo in iz katere tvorimo izhod.
    
    % ugotovim dimenzije
    [maxx maxy] = size(pic);
   
    cb3 = 1; %get(handles.checkbox3,'Value');
    cb4 = 0; %get(handles.checkbox4,'Value');
    cb5 = 0; %get(handles.checkbox5,'Value');
    cb6 = 0; %get(handles.checkbox6,'Value');
    % Ugotovim omocje iskanja
    kaj = 1;
    switch kaj
        case 1,
            ob = 5;
        case 2,
            ob = 10;
        case 3,
            ob = 15;
        case 4,
            ob = 20;
        case 5,
            ob = 25;
        case 6,
            ob = 30;
        case 7,
            ob = 35;
        case 8,
            ob = 40;
        case 9,
            ob = 45;
    end;
    
    ocena = sqrt(sum(sum((double(pic)-double(pic2)).^2)));
    obmocje = 0; b_vrh = 1;
    best_pic1 = pic;
    best_pic2 = pic2;
    
    pom_pic = pic;
    pom_pic2 = pic2;
    
    rot_c = cb3 + cb4 + cb5 + cb6;
    rot_m = [90*cb4, 180*cb5, 270*cb6];
    img2 = cpic2;
    for r_c = 1: rot_c      % Zanka za pripravo slike - glede na izbrane rotacije
        if and(or(rot_c ~= 1, cb3 == 0), r_c ~= 1)
            st = 1;
            kol = 0;
            while kol<rot_c-1
                if (rot_m(st)~=0)
                    kol = kol +1;
                end
                st = st +1;
            end
            st = st - 1;
            cpic2 = myimrotate(img2,rot_m(st),'crop');
            pic2 = rgb2gray(cpic2);
            pom_pic2 = pic2;
        else if and( r_c == 1, cb3 == 0)
                if cb4
                    cpic2 = myimrotate(img2,90,'crop');
                    pic2 = rgb2gray(cpic2);
                    pom_pic2 = pic2;
                end
                if cb5
                    cpic2 = myimrotate(img2,180,'crop');
                    pic2 = rgb2gray(cpic2);
                    pom_pic2 = pic2;
                end
                if cb6
                    cpic2 = myimrotate(img2,270,'crop');
                    pic2 = rgb2gray(cpic2);
                    pom_pic2 = pic2;
                end            
            end
        end
        for vrh = 1:1
            for obm = 7:-1:1   % Zanka poskusov za Binarizacijo 
                % Izracunam koordinat tezisc     
                m1 = 1;
                mx = round((maxx-1)/2);
                my = round((maxy-1)/2);
                m2 = 1;
                mx2 = round((maxx-1)/2);
                my2 = round((maxy-1)/2);

                out = binariziraj(pic,pic2,obm-1,vrh);
                n1 = out(:,:,1);
                n2 = out(:,:,2);

                % Izracun tezisc
                [r c] = find(n1==1);
                mx = mx + sum(r);
                my = my + sum(c);
                m1 = size(r); m1 = m1(1) + 1;
                
                [r c] = find(n2==1);
                mx2 = mx2 + sum(r);
                my2 = my2 + sum(c);
                m2 = size(r); m2 = m2(1) + 1;
                
                clear c;
                clear r;
                %
                
                clear n1;
                clear n2;
                
                % Izracunam koordinate tezisc
                px1(obm,r_c,vrh) = round(mx / m1);
                py1(obm,r_c,vrh) = round(my / m1);
                px2(obm,r_c,vrh) = round(mx2 / m2);
                py2(obm,r_c,vrh) = round(my2 / m2);
			
                % Popravim drugo sliko - tezisce postavim v center 
                dx = round((maxx-1)/2) - px2(obm,r_c,vrh);
                dy = round((maxy-1)/2) - py2(obm,r_c,vrh);

                adx = abs(dx);
                ady = abs(dy);   
                nov = zeros(maxx+2*adx,maxy+2*ady) + 255;
                
                a = (1:maxx) + dx;
                b = (1:maxy) + dy;

                nov(uint16(adx+1:adx+maxx),uint16(ady+1:ady+maxy)) = pic2; 
                pic2 = uint8(nov(adx+1:adx+maxx, ady+1:ady+maxy));
                
                clear nov; 
                
                % Popravim prvo sliko - tezisce postavim v center 
                dx = round((maxx-1)/2) - px1(obm,r_c,vrh);
                dy = round((maxy-1)/2) - py1(obm,r_c,vrh);
                adx = abs(dx);
                ady = abs(dy);   
                nov = zeros(maxx+2*adx,maxy+2*ady) + 255;
                
                a = (1:maxx) + dx;
                b = (1:maxy) + dy;
			
                nov(adx+1:adx+maxx,ady+1:ady+maxy) = pic;
                pic = uint8(nov(adx+1:adx+maxx, ady+1:ady+maxy));
                
                clear nov;
                
                % Sivinski izris
                axis(handles.axes2);
                image(uint8(double(pic)/2+double(pic2)/2));
                colormap(gray(256));
                axis equal;
                axis on;
                pause(0.01);
                
                nocena = sqrt(sum(sum((double(pic)-double(pic2)).^2)));
                
                if ocena > nocena       % Zabelezim morebitno boljso poravnavo
                    obmocje = obm;
                    ocena = nocena;
                    best_pic1 = pic;
                    best_pic2 = pic2;
                    br_c = r_c;
                    b_vrh = vrh;
                end
                
                clear pic;
                clear pic2;
                
                pic = pom_pic;
                pic2 = pom_pic2;
            end
        end
    end
    
    clear pom_pic;
    clear pom_pic2;
    clear img2;
    
    if obmocje ~= 0
        x1 = px1(obmocje,br_c,b_vrh);
        y1 = py1(obmocje,br_c,b_vrh);
        x2 = px2(obmocje,br_c,b_vrh);
        y2 = py2(obmocje,br_c,b_vrh);
        
        pic = best_pic1;
        pic2 = best_pic2;
    else 
        x1 = round((maxx-1)/2);
        y1 = round((maxy-1)/2);
        x2 = round((maxx-1)/2);
        y2 = round((maxy-1)/2);      
    end
    
    clear best_pic1;
    clear best_pic2;
    
    % Sivinski izris
    axis(handles.axes2);
    image(uint8(double(pic)/2+double(pic2)/2));
    colormap(gray(256));
    axis equal;
    axis on;
    pause(0.01);
    
    % Ocenim trenutno prilagajanje
    rot = 0;
    ocena = sqrt(sum(sum((double(pic)-double(pic2)).^2)));
    
    %%%%%    
    rott = 0;
    % ocenim grobo prilagajanje - I. faza      
    for r=-5:5:5
        nova = myimrotate(pic2,r,'crop'); 
              
        nocena = sqrt(sum(sum((double(pic)-double(nova)).^2)));
        if (nocena<ocena)
           ocena = nocena;
           rot = r;
        end
        
        % Sivinski izris
        axis(handles.axes2);
        image(uint8(double(pic)/2+double(nova)/2));
        colormap(gray(256));
        axis equal;
        axis on;
        pause(0.01);
        clear nova;
    end

    % II. faza - bolj natancno prilagajanje
    nasel = 0;
    rott = rot;
    nova1 = myimrotate(pic2,rott-1,'crop');
    nova2 = myimrotate(pic2,rott+1,'crop');
    % Ugotovim katera rotcija je boljsa -> v - ali + stran 
    nocena1 = sqrt(sum(sum((double(pic)-double(nova1)).^2)));
    nocena2 = sqrt(sum(sum((double(pic)-double(nova2)).^2)));
    
    if nocena1 < ocena      % Boljsa je prva (-)
        dif = -1;
        rott = rott -1;
        nasel = 1;
        ocena = nocena1;
    end
    % Sivinski izris
    axis(handles.axes2);
    image(uint8(double(pic)/2+double(nova1)/2));
    colormap(gray(256));
    axis equal;
    axis on;   
    pause(0.01);
    clear nova1;
    
    if nocena2 < ocena      % boljsa je druga (+)
        dif = 1;
        rott = rott + 1;
        nasel = 1;
        ocena = nocena2;
    end
    % Sivinski izris
    axis(handles.axes2);
    image(uint8(double(pic)/2+double(nova2)/2));
    colormap(gray(256));
    axis equal;
    axis on;   
    pause(0.01);
    clear nova2;
    
    while nasel     % V primeru,da sem nasel boljse prilagajanje, nadaljujem v tej smeri
       nasel = 0;
       nova = myimrotate(pic2,rott+dif,'crop'); 
       nocena = sqrt(sum(sum((double(pic)-double(nova)).^2)));
       if (nocena<ocena)
          ocena = nocena;
          rott = rott + dif;
          nasel = 1;
       end
        
       % Sivinski izris
       axis(handles.axes2);
       image(uint8(double(pic)/2+double(nova)/2));
       colormap(gray(256));
       axis equal;
       axis on;   
       pause(0.01);
       clear nova;
   end
    
   if (rott~=0)
       pic2 = myimrotate(pic2,rott,'crop');
   end
    
    %%%%%
    % V okolici poiscem morebitno boljso poravnavo
    nasel = 1;
    bx = 0;
    by = 0;
    while nasel,
        nasel = 0;
        bpic = pic2;
        star_bx = bx;
        star_by = by;
        for x = -2:2:2
            for y = -2:2:2
                star_pic = pic2;
                nov = zeros(size(pic2)+[4,4]) + 255;
                nov(3+x:2+x+maxx,3+y:2+y+maxy) = pic2;
                pic2 = nov(3:2+maxx,3:2+maxy);
    
                nocena = sqrt(sum(sum((double(pic)-double(pic2)).^2)));
                if nocena<ocena
                    ocena = nocena;
                    bx = star_bx + x;
                    by = star_by + y;
                    bpic = pic2;
                    nasel = 1;
                end
                
                % Sivinski izris
                axis(handles.axes2);
                image(uint8(double(pic)/2+double(pic2)/2));
                colormap(gray(256));
                axis equal;
                axis on;   
                pause(0.01);
                clear nov;
                pic2 = star_pic;
            end
        end
        pic2 = bpic;
        clear bpic;
        
        % Sivinski izris
        axis(handles.axes2);
        image(uint8(double(pic)/2+double(pic2)/2));
        colormap(gray(256));
        axis equal;
        axis on;   
        pause(0.01);    
    end
    
    % Se fina groba poravnava
    bpic = pic2;
    star_bx = bx;
    star_by = by;
    for x = -1:1:1
        for y = -1:1:1
            star_pic = pic2;
            nov = zeros(size(pic2)+[2,2]) + 255;
            nov(2+x:1+x+maxx,2+y:1+y+maxy) = pic2;
            pic2 = nov(2:1+maxx,2:1+maxy);

            nocena = sqrt(sum(sum((double(pic)-double(pic2)).^2)));
            if nocena<ocena
                ocena = nocena;
                bx = star_bx + x;
                by = star_by + y;
                bpic = pic2;
            end
            
            % Sivinski izris
            axis(handles.axes2);
            image(uint8(double(pic)/2+double(pic2)/2));
            colormap(gray(256));
            axis equal;
            axis on;   
            pause(0.01);
            clear nov;
            pic2 = star_pic;
        end
    end
    pic2 = bpic;
    clear bpic;
    %%%%%
    
    % Sivinski izris
    axis(handles.axes2);
    image(uint8(double(pic)/2+double(pic2)/2));
    colormap(gray(256));
    axis equal;
    axis on;   
    pause(0.01);    
    
    
    %%%                                                      %%%
    % Sedaj zakljucim s translacijo/rotacijo na barvnih slikah %
    %%%                                                      %%%
    
    % 1. Traslacijo/rotacijo opravim se na barvni sliki - druga slika
    dx1 = round((maxx-1)/2) - x1;
    dy1 = round((maxy-1)/2) - y1;
    dx2 = round((maxx-1)/2) - x2;
    dy2 = round((maxy-1)/2) - y2;
    adx = max([abs(dx1),abs(dx2)]);
    ady = max([abs(dy1),abs(dy2)]);
    abx = abs(bx);
    aby = abs(by);
    
    nova = zeros(size(cpic2) + [2*adx 2*ady 0]) + 255;
    nova(adx+1+dx2:adx+maxx+dx2, ady+1+dy2:ady+maxy+dy2,:) = cpic2;

    if rott~=0
        nova = myimrotate(nova,rott/2,'bilinear','crop');
    end
    
    nova2 = zeros(size(nova) + [2*abx 2*aby 0]) + 255;
    nova2(1+abx+bx:abx+maxx+bx+2*adx, 1+aby+by:maxy+aby+by+2*ady, :) = nova;
    nova = nova2(1+abx:abx+maxx+2*adx, 1+aby:maxy+aby+2*ady, :);
    clear nova2;
    cpic2 = uint8(nova(adx+1+dx1:adx+maxx+dx1,ady+1+dy1:maxy+ady+dy1,:));
    clear nova;    
    
    % Prva slika
    if rott~=0
        nova = zeros(size(cpic2) + [2*adx 2*ady 0]) + 255;
        nova(adx+1+dx1:adx+maxx+dx1, ady+1+dy1:ady+maxy+dy1,:) = cpic;
        
        nova = myimrotate(nova,-rott/2,'bilinear','crop');
        
        cpic = uint8(nova(adx+1+dx1:adx+maxx+dx1, ady+1+dy1:ady+maxy+dy1, :));
    end
    
    pic2 = uint8(rgb2gray(cpic2));
    pic = uint8(rgb2gray(cpic));
    
    % Sivinski izris
    axis(handles.axes2);
    image(uint8(double(pic)/2+double(pic2)/2));
    colormap(gray(256));
    axis equal;
    axis on;   
    pause(0.01);

    ncpic2(:,:,1:3) = cpic2;
    ncpic2(:,:,4) = pic2;
    
    ncpic2(:,:,5:7) = cpic;
    ncpic2(:,:,8) = pic;
    
    GP = ncpic2;