function out = Binariziraj(pic, pic2, obmocje,n_vrh);
%
% Funkcija binariziraj binarizira vhodno sliko glede na obmocje dovoljenih
% krsitev v  histogramu. Deluje v dveh korakih:
%
% 1.) Izracun histograma. Na podlagi histograma se dolocijo meje od kod in
% do kam bomo izlocili elemente. Izlocijo se elementi slike, ki izstopajo
% (so najbolje zastpani - ozadje). Meje se dolocijo na podlagi stevila 
% dovoljenih krsitev (koliko vnosov lahko vmes izstopa).
%
% 2.) Na podlagi mej izracuna binarizirano sliko.
%

h1 = histogram(double(pic));    % Histogram 1
h2 = histogram(double(pic2));   % Histogram 2

for vrh=1:n_vrh  % kater vrh izlocim iz histograma
	% 1. Poiscem ozadje in ga odstranim
	[vred kje] = max(h1);
	od = kje;
	do = kje;
	sred = kje;
	razpon = 100;
	% Poiscem spodnjo mejo
	if od > 1
        st = obmocje;
        minh = od;
		while and(and(st > 0, od>1), sred-od < razpon),
            if h1(od)<h1(od-1)
                st = st -1;
            else
                st = obmocje;
                if (h1(minh) > h1(od))  % novi minimum
                    minh = od;  
                end
            end
            od = od - 1;
		end
        if od==2
            if h1(od)>h1(od-1)
                do = 1;    
            end
        end
        if sred-od == 100
            od = minh;
        end
	end
	% Poiscem zgornjo mejo
	if do < 256
        st = obmocje;
        minh = do;
		while and(and(st > 0, do<255),  do-sred < razpon),
            if h1(do)<h1(do+1)
                st = st - 1;
            else
                st = obmocje;
                if (h1(minh) > h1(do))  % novi minimum
                    minh = do;  
                end
            end
            do = do + 1;
		end
        if do==255
            if h1(do)>h1(do+1)
                do = 256;    
            end
        end
        if do-sred == 100
            do = minh;
        end
	end
    
    % 1. Poiscem ozadje in ga odstranim
	[vred kje] = max(h2);
	od2 = kje;
	do2 = kje;
	sred = kje;
	razpon = 100;
	% Poiscem spodnjo mejo
	if od2 > 1
        st = obmocje;
        minh = od2;
		while and(and(st > 0, od2>1), sred-od2 < razpon),
            if h2(od2)<h2(od2-1)
                st = st -1;
            else
                st = obmocje;
                if (h2(minh) > h2(od2))  % novi minimum
                    minh = od2;  
                end
            end
            od2 = od2 - 1;
		end
        if od2==2
            if h2(od2)>h2(od2-1)
                do2 = 1;    
            end
        end
        if sred-od2 == 100
            od2 = minh;
        end
	end
	% Poiscem zgornjo mejo
	if do2 < 256
        st = obmocje;
        minh = do2;
		while and(and(st > 0, do2<255),  do2-sred < razpon),
            if h2(do2)<h2(do2+1)
                st = st - 1;
            else
                st = obmocje;
                if (h2(minh) > h2(do2))  % novi minimum
                    minh = do2;  
                end
            end
            do2 = do2 + 1;
		end
        if do2==255
            if h2(do2)>h2(do2+1)
                do2 = 256;    
            end
        end
        if do2-sred == 100
            do2 = minh;
        end
	end
	
	% Izlocim obmocje iz histograma
	h1(od:do) = zeros(1,do-od+1);
end

if od > od2
    od = od2;
end
if do2 > do
    do = do2;
end


% mat = [ -1, -1, -1; -1, 6, -1; -1, -1, -1];
% figure
% imshow(filter2(mat,~(or(and(pic<=do-1,pic>=od-1),pic>245))));
% figure
% imshow(filter2(mat,~(or(and(pic2<=do-1,pic2>=od-1),pic2>245))));
% figure
% figure
% imshow(~(or(and(pic<=do-1,pic>=od-1),0)));
% figure
% imshow(~(or(and(pic2<=do-1,pic2>=od-1),0)));
% figure


%mat = [ 0, -1, 0; -1, 4, -1; 0, -1, 0];
%out = filter2(mat,~(or(and(pic<=do-1,pic>=od-1),pic>245)));
out(:,:,1) = ~(and(pic<=do-1,pic>=od-1));
out(:,:,2) = ~(and(pic2<=do-1,pic2>=od-1));
