function varargout = gui(varargin)
% GUI M-file for gui.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui

% Last Modified by GUIDE v2.5 12-Nov-2007 11:58:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
    global  pic1 pic2 kstop kpremik s1 s2 s1r s2r tip_prik inttip

%This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui (see VARARGIN)

% Choose default command line output for gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

    % My init.  
    axes(handles.axes2);
    cla;
    reset(gca);
    axis off;

    pic1 = [];
    pic2 = [];
    kstop = 1;
    kpremik = 1;
    s1 = 1;
    s2 = 1;
    s1r(1:3) = ones(1,3);
    s2r(1:3) = ones(1,3);
    tip_prik = 0;
    set(handles.radiobutton2, 'Value', 0);
    set(handles.radiobutton1, 'Value', 1);
    inttip = 'nearest';
    set(handles.radiobutton3, 'Value', 1);
    set(handles.radiobutton4, 'Value', 0);
             

% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% Premik GOR.
function pushbutton1_Callback(hObject, eventdata, handles)
    global kpremik pic1 inttip

    [dy dx dd] = size(pic1);
    T = [1 0 0; 0 1 0; 0 -kpremik 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'XData', [1 dx], 'YData', [1 dy], 'FillValue', 255); 
    
    Osvezi(handles);

% Premik DOL.
function pushbutton2_Callback(hObject, eventdata, handles)
    global kpremik pic1 inttip

    [dy dx dd] = size(pic1);
    T = [1 0 0; 0 1 0; 0 kpremik 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'XData', [1 dx], 'YData', [1 dy], 'FillValue', 255); 
    
    Osvezi(handles);

% Premik LEVO.
function pushbutton5_Callback(hObject, eventdata, handles)
    global kpremik pic1 inttip

    [dy dx dd] = size(pic1);
    T = [1 0 0; 0 1 0; -kpremik 0 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'XData', [1 dx], 'YData', [1 dy], 'FillValue', 255); 
    
    Osvezi(handles);

% Premik DESNO.
function pushbutton6_Callback(hObject, eventdata, handles)
    global kpremik pic1 inttip

    [dy dx dd] = size(pic1);
    T = [1 0 0; 0 1 0; kpremik 0 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'XData', [1 dx], 'YData', [1 dy], 'FillValue', 255); 
    
    Osvezi(handles);

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% Korak premika.
function edit1_Callback(hObject, eventdata, handles)
    global kpremik
    
    kpremik = str2num(get(handles.edit1, 'String'));


% Zasuk LEVO.
function pushbutton7_Callback(hObject, eventdata, handles)
    global kstop pic1 inttip

    [dy dx dd] = size(pic1);
    kc = cos(deg2rad(-kstop));
    ks = sin(deg2rad(-kstop));
    T = [kc ks 0; -ks kc 0; 0 0 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'FillValue', 255); 
    
    Osvezi(handles);

% Zasuk DESNO.
function pushbutton8_Callback(hObject, eventdata, handles)
    global kstop pic1 inttip

   % [dy dx dd] = size(pic1);
    kc = cos(deg2rad(kstop));
    ks = sin(deg2rad(kstop));
    T = [kc ks 0; -ks kc 0; 0 0 1];
    tform = maketform('affine', T);
    pic1 = imtransform(pic1, tform, inttip, 'FillValue', 255); 
    
    Osvezi(handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% Korak ZASUKA.
function edit2_Callback(hObject, eventdata, handles)
    global kstop
    
    kstop = str2num(get(handles.edit2, 'String'));


% Load img #1.
function pushbutton9_Callback(hObject, eventdata, handles)
    global pic1 pic2 dimx dimy
    
   pic1 = [];
    pic2 = [];
    
    [dat,pot] = uigetfile({'*.bmp';'*.jpg';'*.tif';'*.*'}, 'Slika #1');
    if dat~=0
        kaj = [pot dat];
        pic1 = uint8(imread(kaj));
        
        [dimy dimx dimd] = size(pic1);
        
        Osvezi(handles);
    end


% Load img #2.
function pushbutton10_Callback(hObject, eventdata, handles)
    global pic2
        
    [dat,pot] = uigetfile({'*.bmp';'*.jpg';'*.tif';'*.*'}, 'Slika #2');
    if dat~=0
        kaj = [pot dat];
        pic2 = uint8(imread(kaj));
        
        Osvezi(handles);
    end


% Prikaz PRVE SLIKE.
function checkbox1_Callback(hObject, eventdata, handles)
    global s1
    
    s1 = not(s1);
    Osvezi(handles);


% Prikaz DRUGE SLIKE.
function checkbox2_Callback(hObject, eventdata, handles)
    global s2
    
    s2 = not(s2);
    Osvezi(handles);


% Barvna ravnina S1(R).
function checkbox3_Callback(hObject, eventdata, handles)
    global s1r

    s1r(1) = not(s1r(1));
    Osvezi(handles);

% Barvna ravnina S1(G).
function checkbox4_Callback(hObject, eventdata, handles)
    global s1r

    s1r(2) = not(s1r(2));
    Osvezi(handles);


% Barvna ravnina S1(B).
function checkbox5_Callback(hObject, eventdata, handles)
    global s1r

    s1r(3) = not(s1r(3));
    Osvezi(handles);


% Barvna ravnina S2(R).
function checkbox6_Callback(hObject, eventdata, handles)
    global s2r

    s2r(1) = not(s2r(1));
    Osvezi(handles);


% Barvna ravnina S2(G).
function checkbox7_Callback(hObject, eventdata, handles)
    global s2r

    s2r(2) = not(s2r(2));
    Osvezi(handles);


% Barvna ravnina S2(B).
function checkbox8_Callback(hObject, eventdata, handles)
    global s2r

    s2r(3) = not(s2r(3));
    Osvezi(handles);


% Izbira BARVNO / SIVINSKO.
function radiobutton1_Callback(hObject, eventdata, handles)
    global tip_prik 

    if (get(handles.radiobutton1, 'Value') == 1)
        tip_prik = 0;
        set(handles.radiobutton2, 'Value', 0);
    end
    
    Osvezi(handles);

% Izbira BARVNO / SIVINSKO.
function radiobutton2_Callback(hObject, eventdata, handles)
    global tip_prik 

    if (get(handles.radiobutton2, 'Value') == 1)
        tip_prik = 1;
        set(handles.radiobutton1, 'Value', 0);
    end
    
    Osvezi(handles);


function Osvezi(handles)
    global pic1 pic2 tip_prik s1 s2 s1r s2r dimy dimx
    
    [dimy dimx dimd] = size(pic1);
    
    ppic1 = uint8(zeros(dimy, dimx, 3));
    ppic2 = ppic1;
    if and((s1r(1)), not(isempty(pic1)))
        ppic1(:,:,1) = pic1(:,:,1);
    end
    if and((s1r(2)), not(isempty(pic1)))
        ppic1(:,:,2) = pic1(:,:,2);
    end
    if and((s1r(3)), not(isempty(pic1)))
        ppic1(:,:,3) = pic1(:,:,3);
    end
    if and((s2r(1)), not(isempty(pic2)))
        ppic2(:,:,1) = pic2(:,:,1);
    end
    if and((s2r(2)), not(isempty(pic2)))
        ppic2(:,:,2) = pic2(:,:,2);
    end
    if and((s2r(2)), not(isempty(pic2)))
        ppic2(:,:,3) = pic2(:,:,3);
    end
    
    out = [];
    if and( and( not(isempty(pic1)), not(isempty(pic2)) ), and(s1, s2) )
        
        out = uint8(double(ppic1)/2 + double(ppic2)/2);    
        
    elseif and(not(isempty(pic1)), s1)
        
        out = ppic1;
        
    elseif and(not(isempty(pic2)), s2)
        
        out = ppic2;
        
    end
    
    if (tip_prik == 1)
    
        out = rgb2gray(out);
        
    end
    
    set(handles.frame9, 'Visible', 'off');

    axes(handles.axes2);
    cla;
    reset(gca);
    imshow(out);
    
    axis equal;
    axis on;
    zoom on;
    
    set(handles.axes2, 'XAxisLocation', 'top');

% Interpolacija NAJBLIJIH SOSEDOV.
function radiobutton3_Callback(hObject, eventdata, handles)
    global inttip
    
    if (get(handles.radiobutton3, 'Value') == 1)
        inttip = 'nearest';
        set(handles.radiobutton4, 'Value', 0);
    end

% Interpolacija - KUBINA.
function radiobutton4_Callback(hObject, eventdata, handles)
    global inttip

    if (get(handles.radiobutton4, 'Value') == 1)
        inttip = 'bicubic';
        set(handles.radiobutton3, 'Value', 0);
    end

% Prikaz HISTOGRAMA.
function pushbutton11_Callback(hObject, eventdata, handles)
    global pic1
    
    figure; imhist(rgb2gray(pic1));

% Groba PORAVNAVA.
function pushbutton12_Callback(hObject, eventdata, handles)
    global pic1 pic2
    
    ccpic2 = GrobaPoravnava2(rgb2gray(pic1),rgb2gray(pic2),pic2,pic1,handles);
    pic2 = ccpic2(:,:,1:3);
    pic1 = ccpic2(:,:,5:7);
    
    Osvezi(handles);

% Poravnaj FINO.
function pushbutton13_Callback(hObject, eventdata, handles)
    global pic1 pic2
    
    nnpic2 = FinaPoravnava(rgb2gray(pic1), rgb2gray(pic2), pic1, pic2, handles.axes2);
    pic2 = nnpic2(:,:,1:3);
    pic1 = nnpic2(:,:,5:7);

    Osvezi(handles);


% Prikaz RAZLIK.
function pushbutton14_Callback(hObject, eventdata, handles)
    global pic1 pic2
    
    Osvezi2(uint8( abs(double(pic1) - double(pic2))), handles);


% Prikaz RAZLIK (R).
function pushbutton15_Callback(hObject, eventdata, handles)
    global pic1 pic2 dimy dimx
    
    raz = uint8(zeros(dimy, dimx, 3));
    raz(:,:,1) = uint8( abs(double(pic1(:,:,1)) - double(pic2(:,:,1))));
    Osvezi2( raz, handles);


% Prikaz RAZLIK (G).
function pushbutton16_Callback(hObject, eventdata, handles)
    global pic1 pic2 dimy dimx
    
    raz = uint8(zeros(dimy, dimx, 3));
    raz(:,:,2) = uint8( abs(double(pic1(:,:,2)) - double(pic2(:,:,2))));
    Osvezi2( raz, handles);

% Prikaz RAZLIK (B).
function pushbutton17_Callback(hObject, eventdata, handles)
    global pic1 pic2 dimy dimx
    
    raz = uint8(zeros(dimy, dimx, 3));
    raz(:,:,3) = uint8( abs(double(pic1(:,:,3)) - double(pic2(:,:,3))));
    Osvezi2( raz, handles);


% Doda um.
function pushbutton18_Callback(hObject, eventdata, handles)
    global pic1
    
    pic1 = imnoise(pic1, 'gaussian', 0, 0.05);

    Osvezi(handles);

% Nizko sito.
function pushbutton19_Callback(hObject, eventdata, handles)
    global pic1
    
    mat = 1/9 * ones(3,3);
    pic1(:,:,1) = filter2(mat, pic1(:,:,1));
    pic1(:,:,2) = filter2(mat, pic1(:,:,2));
    pic1(:,:,3) = filter2(mat, pic1(:,:,3));
    
    Osvezi(handles);
    

% Odkrivanje tok.
function pushbutton20_Callback(hObject, eventdata, handles)
    global pic1
    
    gpic1 = rgb2gray(pic1);
    m = [ -1, -1, -1; -1, 8, -1; -1, -1, -1];
    ns = abs(imfilter(double(gpic1), m));
    
    Osvezi2(ns == max(max(ns)), handles);


% Odkrivanje rt.
function pushbutton21_Callback(hObject, eventdata, handles)
    global pic1
    
    gpic1 = rgb2gray(pic1);
    
    m = [ -1, -1, -1; 2, 2, 2; -1, -1, -1];
    ns1 = abs(imfilter(double(gpic1), m));
    
    m = [ -1, -1, 2; -1, 2, -1; 2, -1, -1];
    ns2 = abs(imfilter(double(gpic1), m));

    m = [ -1, 2, -1; -1, 2, -1; -1, 2, -1];
    ns3 = abs(imfilter(double(gpic1), m));
    
    m = [ 2, -1, -1; -1, 2, -1; -1, -1, 2];
    ns4 = abs(imfilter(double(gpic1), m));
    
    Osvezi2( or(or(ns1, ns2), or(ns3, ns4)), handles);
    
    
% Odkrivanje robov - SOBEL.
function pushbutton22_Callback(hObject, eventdata, handles)
    global pic1

    gpic1 = rgb2gray(pic1);
    
    Osvezi2(edge(gpic1, 'sobel'), handles);

% Odkrivanje robov - PREWITT.
function pushbutton23_Callback(hObject, eventdata, handles)
    global pic1

    gpic1 = rgb2gray(pic1);
    
    Osvezi2(edge(gpic1, 'prewitt'), handles);


% Odkrivanje robov - ROBERTS.
function pushbutton24_Callback(hObject, eventdata, handles)
    global pic1

    gpic1 = rgb2gray(pic1);
    
    Osvezi2(edge(gpic1, 'roberts'), handles);


% Operator EROZIJE.
function pushbutton25_Callback(hObject, eventdata, handles)
    global pic1

    se = strel('ball',3,3);
    pic1 = imdilate(pic1, se);
    
    Osvezi(handles);

% Operator RAZTEZANJA.
function pushbutton26_Callback(hObject, eventdata, handles)
    global pic1

    se = strel('ball',3,3);
    pic1 = imerode(pic1, se);
    
    Osvezi(handles);

    
function Osvezi2(pic, handles)
   
    set(handles.frame9, 'Visible', 'off');

    axes(handles.axes2);
    cla;
    reset(gca);
    imshow(pic);
    
    axis equal;
    axis on;
    zoom on;

    set(handles.axes2, 'XAxisLocation', 'top');


% Normalizacija HISTOGRAMA.
function pushbutton27_Callback(hObject, eventdata, handles)
    global pic1
    
    npic1 = histeq(rgb2gray(pic1), 256);
       
    Osvezi2(npic1,handles);

    figure; imhist(npic1);


% Razpoznavanje oblik - BINARIZACIJA.
function pushbutton28_Callback(hObject, eventdata, handles)
    global pic1 

    pic1 = rgb2gray(pic1);
    
    min = 256;
    max = 0;
    vel = size(pic1);
    for x= 1:double(vel(1))
        for y = 1:double(vel(2))
            if max < pic1(x,y)
                max = double(pic1(x,y));
            end
            if min > pic1(x,y)
                min = double(pic1(x,y));
            end            
        end
    end
    tr = (max - min) / 2;
    
    pic1 = not(pic1 < tr);
    
    Osvezi2(not(pic1)*255,handles);

% Razpoznavanje oblik - SEGMENTACIJA.
function pushbutton29_Callback(hObject, eventdata, handles)
    global pic1 klas razred
    
    vel = size(pic1);
    st = 1;
    klas = MySegmentation(pic1);
    
    razred = zeros(1000,1);
    for x=1:double(vel(1))
        for y=1:double(vel(2))
            if klas(x,y)~=0
                nasel = 0;
                for i=1:st
                    if razred(i)==klas(x,y)   
                        nasel = 1;  
                    end
                end
                if nasel == 0
                    razred(st) = klas(x,y);
                    st = st + 1;
                end
            end
        end
    end
    st = st - 1;
    razred = razred(1:st);
    
    Osvezi2(uint8(255 * klas / max(max(klas))), handles);
    
    
% Razpoznavanje oblik - DOLOCITEV ZNACILK.
function pushbutton30_Callback(hObject, eventdata, handles)
    global klas razred znacilke
   
    znacilke = MyFeatureExtraction(razred, klas);


% Razpoznavanje oblik - KLASIFIKACIJA.
function pushbutton31_Callback(hObject, eventdata, handles) 
    global pic1 znacilke klas razred
    
    MyClassifier(pic1, znacilke, klas, razred);




% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
    global pic1
    
    prag = get(hObject,'Value');
    
    pic = pic1;
    [my mx dim] = size(pic1);
    pic = zeros(my, mx, dim);
    
    if (get(handles.checkbox3, 'Value') == 1)
        pic(:,:,1) = uint8( double(pic1(:,:,1)) .* (pic1(:,:,1) >= prag) );
    end
    
    if (get(handles.checkbox4, 'Value') == 1)
        pic(:,:,2) = uint8( double(pic1(:,:,2)) .* (pic1(:,:,2) >= prag) );
    end
    
    if (get(handles.checkbox5, 'Value') == 1)
        pic(:,:,3) = uint8( double(pic1(:,:,3)) .* (pic1(:,:,3) >= prag) );
    end
    
    Osvezi2(uint8(pic), handles); 

% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton33.
function pushbutton33_Callback(hObject, eventdata, handles)
    global pic1
    
    hsi(pic1);

